// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: statsget
// Author: Hassan Siddiqui
//
// Description: which returns statistical information 
// about specified columns in a given file.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: statsget.cc,v 1.6 2000/01/27 13:05:00 hsiddiqu Exp $




// General classes

#include <iostream.h>
#include <fstream.h>
#include <string>

// SAS-specific classes

#include "param.h"
#include "Dal.h"

// General utility functions
#include "Tracer.h"

// Utility classes
#include "TableStatistics.h"


// ---------------------------------------------------

// Main function

// ---------------------------------------------------

#include "statsget.h"

void statsget()
{
  PROC;
  
  string tablename=stringParameter("table");

  DataSet * set = dataSetServer->open( tablename, 
				      DataSet::Read);

  Table * table = set->table(tablename);

  // Generate list of desired columns

  //  vector<string> names = breakup(stringParameter("column"));

  vector<string> names = stringListParameter("column");

//    int numberOfColumns = parameterCount("column");
//    for (int i = 0; i< numberOfColumns; i++)
//      {
//        names.push_back(stringParameter("column",i));
//      }
  
//    for (vector<string>::const_iterator it = names.begin();
//         it != names.end();
//         ++it)
//      cout << *it << endl;
//    );  


  /* Generate statistics */
  TableStatistics tablestatistics(*table, names);

  /* Close dataset */
  dataSetServer->close(set);


  /* Write statistics to output */
  errstr << "\n===== STATISTICS ======\n\n" << tablestatistics
	 << Sas::message(Msg::App, Msg::Sparse);
  ofstream outstream(stringParameter("resultfile").c_str());
  outstream << "\n===== STATISTICS ======" << tablestatistics << endl;
  outstream.close();

  ENDPROC;
} 
